#include "Client.h"

// RXgN^
CClient::CClient():m_DstSocket(INVALID_SOCKET)
{
	// Windows ̏ꍇ
	WSADATA data;
	WSAStartup(MAKEWORD(2,0), &data);
}
// fXgN^
CClient::~CClient(){
	if(m_DstSocket != INVALID_SOCKET)
		closesocket(m_DstSocket);
	// Windows ł̃\Pbg̏I
	WSACleanup();
}

// ڑ
bool CClient::Connect(const char* IP,u_short PORT)
{

	// sockaddr_in \̂̃Zbg
	struct sockaddr_in dstAddr;
	memset(&dstAddr, 0, sizeof(dstAddr));
	dstAddr.sin_port = htons(PORT);
	dstAddr.sin_family = AF_INET;
	dstAddr.sin_addr.s_addr = inet_addr(IP);

	// \Pbg̐
	m_DstSocket = socket(AF_INET, SOCK_STREAM, 0);

	// ڑ
	if(connect(m_DstSocket, (struct sockaddr *) &dstAddr, sizeof(dstAddr)) 
		== SOCKET_ERROR){
		return false;
	}
	// \Pbg񓯊[hɂ
	u_long val=1;
	ioctlsocket(m_DstSocket, FIONBIO, &val);
	return true;
}


// M
RECVSTATUS CClient::Recv(char* pData,int DataSize,int *pRecvSize)
{
	
	int n = recv(m_DstSocket, pData, DataSize, 0);
	if (n < 1) {
		// f[^ĂȂ
		if (WSAGetLastError() == WSAEWOULDBLOCK) {
			return RECV_STILL;
		// ؒforG[
		} else {
			return RECV_FAILED;
		}
	} 
	*pRecvSize = n;	// Mf[^擾
	return RECV_SUCCESSED;
}

// M
bool CClient::Send(char* pData,int DataSize)
{
	//pPbg̑M
	if(send(m_DstSocket, pData, DataSize, 0) == SOCKET_ERROR)
		return false;

	return true;
}